Weather.Data = newClass(null, {
	constructor: function(owner) {
		this.platform = Wdgt.platform.name;
		//this.setWeatherId(null);
		this.owner = owner;
		this.current = {};
		this.request_forecast = null;
		this.geo_target_region = 213;
		this.geo_target_weather = 27612;
		this.geo_target_city = 'Москва';
		this.requestCities();
		this.update();
		this.cities = null;
		new y5.Observer('update', this.update, this, true, this);
		Wdgt.preferences.mode('weather-id', 'instance-collection');
		Wdgt.preferences.mode('city', 'instance-collection');
	},

	update: function(params) {
		if (params)
			this.setWeatherId(params.id);
		var context = this;
		function requestForecast() {context.requestForecast.call(context);}
		clearInterval(this.interval_forecast);
		if(this.getWeatherId() != '') {
			this.interval_forecast = setInterval(requestForecast, 3600 * 1000);
			this.requestForecast();
		}
	},
	getCity: function() {
		try {
			return this.cities[this.getWeatherId()].name;
		} catch(e) {
			return Wdgt.preferences.get('city');
		}
	},
	getCityTitle: function() {
		try {
			return this.cities[this.getWeatherId()].title;
		} catch(e) {
			return Wdgt.preferences.get('city');
		}
	},
	/*
	getCityEx: function() {
		var city = this.getCity();
		/ *
		if(Wdgt.platform.name == 'sidebar') {
			if(city.length > 15)
				city = city.substr(0, 14) + '...';
		} * /
		return city;
	},
	*/
	getWeatherId: function() {
		return Wdgt.preferences.get('weather-id', '');
	},
	setWeatherId: function(id, city) {
		Wdgt.preferences.set('weather-id', id);
		if(this.cities)
			city = this.cities[this.getWeatherId()].name;
		Wdgt.preferences.set('city', city);
	},
	requestGeoTarget: function() {
		var context = this;
		function onload(request) {context.responseGeoTarget.call(context, request);}
		var url = new y5.URL('http://export.yandex.ru/bar/reginfo.xml');
		url.addParam('rnd', Math.random());
		try {
			this.request_geo_target = new y5.Request.XML(url.toString());
			this.request_geo_target.onerror = function(e) {context.setDefaultRegion.call(context);};
			this.request_geo_target.onload = onload;
			setTimeout(function() {
				if(context.getWeatherId() == '') {
					context.setWeatherId(context.geo_target_weather, context.geo_target_city);
					context.update();
				}
			}, 3 * 1000);
			this.request_geo_target.send();
		} catch(e) {
		};
	},
	responseGeoTarget: function(request) {
		var xml = request.responseXML;
		try {
			var weather = xml.getElementsByTagName('weather')[0];
			var region = weather.getAttribute('region');
			var city = weather.getElementsByTagName('title')[0].firstChild.nodeValue;
			this.geo_target_region = region;
			if(this.cities) {
				for(var id in this.cities)
					if(this.cities[id].region == region) {
						this.geo_target_weather = id;
						this.geo_target_city = city;
						break;
					}
				
				if(this.getWeatherId() == '')
					this.setWeatherId(this.geo_target_weather, this.geo_target_city);
				this.update();
			}
		} catch (e) {
			this.setDefaultRegion();
		}
	},
	setDefaultRegion: function() {
		this.setWeatherId(this.geo_target_weather, this.geo_target_city);
		this.update();
	},
	requestCities: function() {
		var context = this;
		function onload(request) {context.responseCities.call(context, request);}
		var url = new y5.URL('http://weather.yandex.ru/static/cities.xml');
		url.addParam('rnd', Math.random());
		try {
			this.request_city = new y5.Request.XML(url.toString());
			//this.request_city.onerror = function(e) {}
			this.request_city.onload = onload;
			//setTimeout(function() {request.abort(); request = null;}, 3 * 1000);
			this.request_city.send();
		} catch(e) {
		}
	},
	responseCities: function(request) {
		var xml = request.responseXML;
		var countries = xml.getElementsByTagName('country');
		this.cities = {};
		for(var i = 0; i < countries.length; i++) {
			var country = countries[i];
			var cities = country.getElementsByTagName('city');
			for(var j = 0; j < cities.length; j++) {
				var city = cities[j];
				this.cities[city.getAttribute('id')] = {
					id: city.getAttribute('id'),
					region: city.getAttribute('region'),
					country: city.getAttribute('country'),
					part: city.getAttribute('part'),
					name: city.firstChild.nodeValue
				};
			}
		}

		var index = {}, city;
		for (var i in this.cities) {
			var city = this.cities[i];
			if (typeof index[city.name] == 'undefined')
				index[city.name] = 0;
			index[city.name] ++;
		}

		for (var i in this.cities) {
			var city = this.cities[i];
			city.title = (index[city.name] > 1) ? city.name + ' (' + city.country + (city.part ? ', ' + city.part : '') + ')' : city.name;
		}


		if(this.cities)
			this.requestGeoTarget();
	},
	requestForecast: function() {
		this.current = {};
		var context = this;
		function onload(request) {context.responseForecast.call(context, request);}
		function onerror(request) {setTimeout(function() {context.requestForecast.call(context);}, 1000 * 60 * 5);}
		var url = new y5.URL('http://export.yandex.ru/weather-ng/forecasts/' + this.getWeatherId() + '.xml');
		url.addParam('rnd', Math.random());
		try {
			this.request_forecast = new y5.Request.XML(url.toString());
			this.request_forecast.onerror = onerror;
			this.request_forecast.onload = onload;
			this.request_forecast.send();
		} catch(e) {
			onerror();
		}
	},
	responseForecast: function(request) {
		var weekdays = {'1': 'пн', '2': 'вт', '3': 'ср', '4': 'чт', '5': 'пт', '6': 'сб', '0': 'вс'};
		var xml = request.responseXML;
		//function node(x, name) {return x.getElementsByTagName(name)[0];};
		function node(x, name) {
			result = x.getElementsByTagName(name)[0];
			// workaround for safari 2 bug (x.getElementsByTagName('image')[0])
			if (!result) {
				var nodes = x.childNodes;
				for (var i = 0; i < nodes.length; i ++)
					if (nodes[i].tagName == name) {
						result = nodes[i];
						break;
					}
			}
			return result;
		};
		function value(x, name) {var x = node(x, name); return x ? x.firstChild.nodeValue : null;}
		function convert(date) {
			date = date.substr(0, 10);
			var d = new Date(0);
			d.setFullYear(date.substr(0, 4), parseInt(date.substr(5, 2), 10) - 1, date.substr(8, 2));
			return {date: d.getDate(), day: weekdays[d.getDay()], object: d};
		}
		var data = {};
		var fact = node(xml, 'fact');
		data.fact = {
			temperature: value(fact, 'temperature'),
			image: value(fact, 'image'),
			type: value(fact, 'weather_type'),
			wind_speed: value(fact, 'wind_speed'),
			wind_direction: value(fact, 'wind_direction'),
			humidity: value(fact, 'humidity'),
			pressure: value(fact, 'pressure'),
			date: convert(value(fact, 'observation_time'))
		};
		data.alert = value(xml, 'alert');
		data.forecast = [];
		var days = xml.getElementsByTagName('day');
		for (var i = 0; i < days.length; i++) {
			var day = days[i];
			var date_day = {
				sunrise: value(day, 'sunrise'),
				sunset: value(day, 'sunset'),
				moonrise: value(day, 'moonrise'),
				moonset: value(day, 'moonset'),
				date: convert(day.getAttribute('date'))				
			}
			
			var parts = day.getElementsByTagName('day_part');
			for (var j = 0; j < parts.length; j++) {
				var part = parts[j];
				var type = part.getAttribute('type');
				if (type == 'day_short' || type == 'night_short') {
					var temperature = value(part, 'temperature');
					if (!temperature) {
						var from = value(part, 'temperature_from');
						var to = value(part, 'temperature_to');
						temperature = from + '...' + to;
					}
					date_day[type == 'day_short' ? 'day' : 'night'] = {
						temperature: temperature,
						image: value(part, 'image'),
						humidity: value(part, 'humidity'),
						pressure: value(part, 'pressure'),
						wind_speed: value(part, 'wind_speed'),
						wind_direction: value(part, 'wind_direction'),
						type: value(part, 'weather_type')
					};
				}
			}
			
			data.forecast.push(date_day);
		}
		
		if (data.fact.date.date == data.forecast[0].date.date)
			data.forecast.splice(0, 1);
		
		this.current.forecast = data;
		this.owner.mode.redraw();
		this.owner.mode.show();
	}
});