Weather.Preferences = newClass(null, {
	constructor: function(owner) {
		this.platform = Wdgt.platform.name;
		this.owner = owner;

		if (this.platform == 'dashboard') {
			new Wdgt.PreferencesButton(y5.Dom.$('preferences-button'), y5.Dom.$('normal'));
			y5.Events.observe('click', this.toggle, y5.Dom.$('preferences-button'), true, this);
			
			new Wdgt.ActiveButton(y5.Dom.$('preferences-done'), y5.Dom.$('preferences'));
			y5.Events.observe('click', this.toggle, y5.Dom.$('preferences-done'), true, this);
		}

		if (this.platform == 'opera') {
			y5.Events.observe('click', this.toggle, y5.Dom.$('panel-button-preferences'), true, this);
			y5.Events.observe('click', function(e) {this.toggle(e);}, y5.Dom.$('preferences-button-ok'), true, this);
			y5.Events.observe('click', function(e) {this.close(e);}, y5.Dom.$('preferences-button-cancel'), true, this);
		}
		
		if (this.platform != 'sidebar') {
			new y5.Observer('city-menu-done', this.toggle, this, true, this);
			this.menu_cities = new Weather.MenuCities(null, {container: y5.Dom.$('preferences'), input: y5.Dom.$('preferences-input-city'), owner: this, avto_save: this.platform != 'opera', data: this.owner.data});
			y5.Events.observe('click', this.skinSelectClick, y5.Dom.$('preferences-skin-select'), true, this);
			y5.ShortCut.down([{key: y5.ShortCut.ESC}], this.close, document, {checkTarget: true, preventDefault: false, context: this});
		}
	},
	toggle: function(e) {
		if (e)
			e.stopPropagation();
		if(this.owner.mode.get('mode') != 'preferences') {
			y5.Dom.$('preferences-status').innerHTML = 'Яндекс.Погода ' + Wdgt.update.getVersion() + ', &copy; 2009-' + (new Date()).getFullYear() + ' &laquo;Яндекс&raquo;<br>Данные предоставлены <a href="#" onclick="Wdgt.utils.openURL(\'http://foreca.ru/\');return false;" onfocus="this.blur();return false;">FORECA</a>';
			y5.Dom.$('preferences-feedback-link').onclick = function(){Wdgt.utils.openURL(Wdgt.feedbackUrl());return false;};
			y5.Dom.$('preferences-input-city').value = this.owner.data.getCityTitle();
			this.owner.mode.set('mode', 'preferences');
			y5.Classes.remove(y5.Dom.getDescendant(y5.Dom.$('preferences-skin-select'), 'div', 'skin-balloon'), 'select');
			y5.Classes.remove(y5.Dom.getDescendant(y5.Dom.$('preferences-skin-select'), 'div', 'skin-dirigible'), 'select');
			y5.Classes.add(y5.Dom.getDescendant(y5.Dom.$('preferences-skin-select'), 'div', 'skin-' + Wdgt.preferences.get('aircraft')), 'select');
			y5.Dom.$('preferences-input-city').focus();
			y5.Dom.$('preferences-input-city').select();
		} else {
			this.menu_cities.store();
			this.owner.mode.set('aircraft', this.skinGetCurrent());
			this.owner.mode.set('mode', 'normal');
		}
	},
	close: function() {
		if(this.owner.mode.get('mode') == 'preferences')
			this.owner.mode.set('mode', 'normal')
	},
	skinSelectClick: function(e) {
		var button = y5.Dom.getAncestor(e.target, 'div', 'skin-preview');
		if(!button)
			return;
		var container = button.parentNode;
		var selected = y5.Dom.getDescendant(container, 'div', 'select');
		y5.Classes.remove(selected, 'select');
		y5.Classes.add(button, 'select');
	},
	skinGetCurrent: function() {
		var button = y5.Dom.getDescendant(y5.Dom.$('preferences-skin-select'), 'div', 'select');
		if(y5.Classes.test(button, 'skin-dirigible'))
			return 'dirigible';
		if(y5.Classes.test(button, 'skin-balloon'))
			return 'balloon';
	}
});